%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Question 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% build function in frequency domain
close all
clear all
subplot(1,2,2)
w=-pi:0.001:pi;
lowpass=(w>-pi/4).*(w<pi/4);
X=(sinc(w*12/pi)).*lowpass;
plot(w,abs(X))
xlabel('\omega', 'FontSize',14)
title('|X(\omega)|', 'FontSize',16)
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)

%% look at the function in the time domain (n)

x=ifft(fftshift(X));
subplot(1,2,1)
stem(10:40, abs(x(10:40)))
xlabel('n', 'FontSize',14)
title('x[n]', 'FontSize',16)
% The next two lines set the size of the output png file. The output will
% be 1024x300 pixels.
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q1f1','-dpng','-r0')

%% downsample by four
x_downsampled=x(1:4:end);

X_downsampled=fftshift(fft(x_downsampled));

figure
subplot(1,2,2)
plot(linspace(-pi,pi,length(X_downsampled)),abs(X_downsampled))
xlabel('\omega', 'FontSize',14)
title('|Y(\omega)|', 'FontSize',16)
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)

subplot(1,2,1)
stem(10:40, abs(x_downsampled(10:40)))
xlabel('n', 'FontSize',14)
title('y[n]', 'FontSize',16)
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q1f2','-dpng','-r0')

%% upsample by four
x_upsampled=zeros(1,4*length(x));
x_upsampled(1:4:end)=x;

X_upsampled=fftshift(fft(x_upsampled));

figure
subplot(1,2,2)
plot(linspace(-pi,pi,length(X_upsampled)),abs(X_upsampled))
xlabel('\omega', 'FontSize',14)
title('|Z(\omega)|', 'FontSize',16)
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)

subplot(1,2,1)
stem(10:40, abs(x_upsampled(10:40)))
xlabel('n', 'FontSize',14)
title('z[n]', 'FontSize',16)
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q1f3','-dpng','-r0')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Question 3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% H(f)
f=-1e3:0.1:1e3;
H=(f>200).*(f<600);

figure
subplot(1,2,1)
plot(f,H)
xlabel('f','FontSize',14)
title('H(f)','FontSize',16)
axis([min(f) max(f) min(H)-0.1*(max(H)-min(H)) max(H)+0.1*(max(H)-min(H))])
grid on

w=-pi:0.001:pi;
w1=(200/6000)*2*pi;
w2=(600/6000)*2*pi;
H1=(w>w1).*(w<w2);

subplot(1,2,2)
plot(w,H1)
xlabel('\omega','FontSize',14)
title('H_1(\omega)','FontSize',16)
axis([min(w) max(w) min(H1)-0.1*(max(H1)-min(H1)) max(H1)+0.1*(max(H1)-min(H1))])
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)
grid on
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q3f1','-dpng','-r0')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Question 4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lfp1=(abs(w)<pi/2)*2;
figure
subplot(1,2,1)
plot(w,lfp1)
xlabel('\omega','FontSize',14)
title('LPF1','FontSize',16)
axis([min(w) max(w) -0.1 2.1])
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)
grid on

w=-pi:0.001:pi;
w1=(200/12000)*2*pi;
w2=(600/12000)*2*pi;
H2=(w>w1).*(w<w2);

subplot(1,2,2)
plot(w,H2)
xlabel('\omega','FontSize',14)
title('H_2(\omega)','FontSize',16)
axis([min(w) max(w) -0.1 1.1])
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)
grid on
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q4f1','-dpng','-r0')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Question 5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lfp2=(abs(w)<pi/2)*2;
figure
subplot(1,2,1)
plot(w,lfp2)
xlabel('\omega','FontSize',14)
title('LPF2','FontSize',16)
axis([min(w) max(w) -0.1 2.1])
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)
grid on

w=-pi:0.001:pi;
w1=(200/3000)*2*pi;
w2=(600/3000)*2*pi;
H3=(w>w1).*(w<w2);

subplot(1,2,2)
plot(w,H3)
xlabel('\omega','FontSize',14)
title('H_3(\omega)','FontSize',16)
axis([min(w) max(w) -0.1 1.1])
set(gca, 'xlim',[-pi() pi()],'xtick',[-pi:pi/4:pi],'xticklabel',...
    {'-p','-3p/4', '-p/2', '-p/4','0','p/4', 'p/2', '3p/4','p'},...
    'FontName','symbol','FontSize',12)
grid on
set(gcf,'Position',[100,100,1024,300],'PaperPositionMode','auto')
print('ece438hw5fa15_q5f1','-dpng','-r0')
